import scriptHandler, globalPluginHandler, ui
import os, sys, winKernel, re, datetime
path = os.path.dirname(__file__)
sys.path.append(path)
from lunar_python import Lunar, Solar

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
  scriptCategory = "農曆報時"
  @scriptHandler.script(description = "播報時間，按兩次顯示日期含農曆資訊", gesture = "kb:NVDA+F12")
  def script_lunar(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 0:
      text = winKernel.GetTimeFormatEx(winKernel.LOCALE_NAME_USER_DEFAULT, winKernel.TIME_NOSECONDS, None, None)
      ui.message(text)
    else:
      text = winKernel.GetDateFormatEx(winKernel.LOCALE_NAME_USER_DEFAULT, winKernel.DATE_LONGDATE, None, None)
      txt = re.sub("年(.*)月(.*)日", ",\\1,\\2", text)
      txt = txt.split(",")
      lunar = Solar.fromYmd(int(txt[0]), int(txt[1]), int(txt[2])).getLunar()
      text += "\n農曆" + lunar.toFullString()
      ui.browseableMessage(text)
